diff --git a/lib/logmsg/tests/test_type_hints.c b/lib/logmsg/tests/test_type_hints.c
index 76ca461fb0..b0ab2eed4d 100644
--- a/lib/logmsg/tests/test_type_hints.c
+++ b/lib/logmsg/tests/test_type_hints.c
@@ -158,6 +158,14 @@ Test(type_hints, test_int32_cast)
   cr_assert_eq(value, 12345);
   cr_assert_null(error);
 
+  cr_assert(type_cast_to_int32("0x1000", &value, &error), "Type cast of \"0x1000\" to gint32 failed");
+  cr_assert_eq(value, 0x1000);
+  cr_assert_null(error);
+
+  cr_assert(type_cast_to_int32("0111", &value, &error), "Type cast of \"0111\" to gint32 failed");
+  cr_assert_eq(value, 0111);
+  cr_assert_null(error);
+
   /* test for invalid string */
   cr_assert_not(type_cast_to_int32("12345a", &value, &error),
                 "Type cast of invalid string to gint32 should be failed");
@@ -185,6 +193,15 @@ Test(type_hints, test_int64_cast)
   cr_assert_eq(value, 12345);
   cr_assert_null(error);
 
+  cr_assert(type_cast_to_int64("0x1000", &value, &error), "Type cast of \"0x1000\" to gint64 failed");
+  cr_assert_eq(value, 0x1000);
+  cr_assert_null(error);
+
+  cr_assert(type_cast_to_int64("0111", &value, &error), "Type cast of \"0111\" to gint64 failed");
+  cr_assert_eq(value, 0111);
+  cr_assert_null(error);
+
+
   /* test for invalid string */
   cr_assert_not(type_cast_to_int64("12345a", &value, &error),
                 "Type cast of invalid string to gint64 should be failed");
diff --git a/lib/logmsg/type-hinting.c b/lib/logmsg/type-hinting.c
index 9d9c1a345b..1754a76ab1 100644
--- a/lib/logmsg/type-hinting.c
+++ b/lib/logmsg/type-hinting.c
@@ -87,7 +87,7 @@ type_cast_to_int32(const gchar *value, gint32 *out, GError **error)
 {
   gchar *endptr;
 
-  *out = (gint32)strtol(value, &endptr, 10);
+  *out = (gint32)strtol(value, &endptr, 0);
 
   if (value[0] == 0 || endptr[0] != '\0')
     {
@@ -104,7 +104,7 @@ type_cast_to_int64(const gchar *value, gint64 *out, GError **error)
 {
   gchar *endptr;
 
-  *out = (gint64)strtoll(value, &endptr, 10);
+  *out = (gint64)strtoll(value, &endptr, 0);
 
   if (value[0] == 0 || endptr[0] != '\0')
     {
diff --git a/news/bugfix-4535.md b/news/bugfix-4535.md
new file mode 100644
index 0000000000..3bf3bed116
--- /dev/null
+++ b/news/bugfix-4535.md
@@ -0,0 +1,2 @@
+`int32()` and `int64()` type casts: accept hex/octal numbers as proper
+number representations just as the @NUMBER@ parser within db-parser().
